// If your presentation is longer than 125 slides,
// you could change the Array size below.
filename = new Array(125);

first_slide = 0;
last_slide = 0;
current_slide = 1;
slides_inserted = 0;
slides_deleted = 0;
show_slide_filename = 0;


/* function AddSlide adds a slide to the presentation at the end.      */
/*                                                                     */
/* parameter name is the name of the file, without the .htm extension. */

function AddSlide(name)
{
	last_slide++;
	if(name == null) name = last_slide-slides_inserted+slides_deleted;
	else {
		slides_inserted++;
	}
	filename[last_slide] = name + ".htm";
}


// DON'T EDIT ANY OF THE TEXT ABOVE THIS LINE!!!
// It's source code you don't need to touch and should not touch.
//
// To add, delete, and reorder slides, 
// just add, delete, and reorder the AddSlide("FILENAME")
// entries below.  Each name in double quotes is the name
// of an HTML file in this presentation directory.
//
// Within the quotes, don't include an extension like .htm or .html.
// This application automatically adds .htm to the name when it
// looks in the directory for the file.  In the directory, the
// HTML file *must* have the three letter extension .htm.


// Keep these first three slides (Logopage, Title, S_agenda)
// in your presentation so we have a standard look and feel.
// (Edit the contents of the Title and S_agenda slide.)

var standup = true
var online  = false

AddSlide("logopage");	// 
AddSlide("title");	// title slide
AddSlide("agenda");   // agenda slide
AddSlide("agenda2");   // agenda slide

AddSlide("V_over")
AddSlide("V_demo")
AddSlide("V_js10ev")
AddSlide("V_summ")
if (online) {
AddSlide("V_ckstr")
AddSlide("V_cknum")
AddSlide("V_ckdata")
AddSlide("V_ckdate")
AddSlide("V_refmt")
AddSlide("V_prompt")
AddSlide("V_ckpsel")
AddSlide("V_credit")
}

AddSlide("V_jvers")
if (online) AddSlide("../dvcnAdJS/Vojvers2");
else AddSlide("../dvcnAdJS/Vijvers2");



AddSlide("E_js12ov")
AddSlide("E_js12wn")
AddSlide("E_js12w2")
AddSlide("E_wnbutt")
AddSlide("E_mousov")
AddSlide("E_trap")
AddSlide("E_keyovr")
AddSlide("Wnbakfor")
AddSlide("Wnhomfin")
AddSlide("Wnpriget")
AddSlide("Wn_pgdem")
// AddSlide("Wn_open")

//----- Window ----------

AddSlide("w_window1");	// 
AddSlide("w_window2");	// 
AddSlide("w_window3");	// 
// AddSlide("w_window4");	// 

AddSlide("Wn_opend") // fix always raised! -- commented out
AddSlide("Wn_pos")
AddSlide("Wn_posd") 
AddSlide("Wn_siz")
AddSlide("Wn_sizd") 
AddSlide("Wnscrol")
AddSlide("Wnscrold") 
AddSlide("Wnscrn")
AddSlide("E_evtobj")
AddSlide("E_evtob2")
AddSlide("E_mousc")
AddSlide("E_mousmv")
AddSlide("E_mousdc")
AddSlide("E_key")
AddSlide("E_keyd")
AddSlide("E_win")
AddSlide("E_caprel")
AddSlide("E_caprea")
AddSlide("E_capre2")


AddSlide("R_over")
AddSlide("R_perl")
AddSlide("R_perlex")
AddSlide("R_meth")
AddSlide("R_demo")
AddSlide("R_compar") 
AddSlide("R_reobj")


AddSlide("A_over")
AddSlide("A_demo")

AddSlide("Z_demo")


AddSlide("agenda2");   // agenda slide


//----- frames ----------

AddSlide("f_frames1");	// 
AddSlide("f_frames2");	// 
AddSlide("f_frames3");	// 
AddSlide("f_frames4");	// 
AddSlide("f_frames5");	// 
AddSlide("f_frames6");	// 
AddSlide("f_frames7");	// 

//----- D Content ----------
AddSlide("d_content1");	// 
AddSlide("d_content2");	// 
AddSlide("d_content3");	// 
AddSlide("d_content4");	// 
AddSlide("d_content5");	// 
AddSlide("d_content6");	// 
AddSlide("d_content8");	// 

//----- Plugin ----------

AddSlide("p_plugin1");	// 
AddSlide("p_plugin2");	// 
AddSlide("p_plugin3");	// 
AddSlide("p_plugin4");	// 
AddSlide("p_plugin5");	// 
AddSlide("p_plugin6");	// 



//----- Cookie ----------

AddSlide("m_cookie1");	// 
AddSlide("m_cookie2");	// 
AddSlide("m_cookie3");	// 
AddSlide("m_cookie4");	// 
AddSlide("m_cookie5");	// 

//----- Shopping ----------
AddSlide("s_shop");	// 


// Keep this last slide (logopage) in your presentation 
// so every presentation ends with the logo.

AddSlide("part_four");	// Next Step
AddSlide("s_24");   	// From Here
AddSlide("s_24b");   	// From Here (2)


AddSlide("logopage");	// 







