function aScreenSize (h1, titlepage, p, li, ul, ol, dl, dt, dd, blockquote, th, td, pre, tt, small, medium, large)
{  this.h1 = h1
   this.titlepage = titlepage
   this.p = p
   this.li = li
   /* PR4 BUG WORKAROUND: Shouldn't be necessary to set fontSize on UL and OL as
      well as LI, but setting LI fontSize doesn't work now.  Setting on UL and OL
      is the workaround. */ 
   this.ul = ul
   this.ol = ol
   this.dl = dl
   this.dt = dt
   this.dd = dd
   this.blockquote = blockquote
   this.th = th
   this.td = td
   this.pre = pre
   this.tt  = tt
   this.small = small
   this.medium = medium
   this.large = large
}

var numberOfScreenSizes = 6

var screenMin = 1
var screen11 = 2
var screen12 = 3
var screen15 = 4
var screen17 = 5
var screen20 = 6

theFontSizes = new Array(numberOfScreenSizes + 1)

theFontSizes[screenMin] = new aScreenSize("27pt", "27pt", "22pt", "22pt", "22pt", "22pt", "22pt", "22pt", "22pt", "22pt", "22pt", "22pt", "22pt", "22pt", "10pt", "14pt", "17pt")

/* 12" monitor of 800x600 pixels is the size which we consider "base"; 
   all other sizes are designed to scale so that their content will fit
   within an 800x600 pixel size area.  This is the pixel size used by 12"
   laptop monitors as well as many overhead display systems. */
theFontSizes[screen12]  = new aScreenSize("34pt", "34pt", "28pt", "28pt", "28pt", "28pt", "28pt", "28pt", "28pt", "28pt", "28pt", "28pt", "28pt", "28pt", "12pt", "18pt", "21pt")


/* 17" monitor of 1024x768 pixels is 1.28x1.28 times larger than 12",
   so scale up by 28% to make sure HTML still fits on smaller page. */
theFontSizes[screen17]  = new aScreenSize("42pt", "42pt", "36pt", "36pt", "36pt", "36pt", "36pt", "36pt", "36pt", "36pt", "36pt", "36pt", "36pt", "36pt", "16pt", "24pt", "27pt")

/* 20" monitor of 1280x1024 pixels is 1.25x1.3 times larger than 17",
   so scale up by 33% to make sure HTML still fits on smaller page. */
theFontSizes[screen20]  = new aScreenSize("56pt", "56pt", "48pt", "48pt", "48pt", "48pt", "48pt", "48pt", "48pt", "48pt", "48pt", "48pt", "48pt", "48pt", "21pt", "32pt", "36pt")

var currentScreen = 0

if (screen.width < 700) { currentScreen = screenMin }
else if ((screen.width > 900) && (screen.width < 1200)) { currentScreen = screen17 }
else if (screen.width >= 1200) { currentScreen = screen20 }
else { currentScreen = screen12 }



document.tags.BODY.color = "black"
document.tags.BODY.backgroundColor = "white"


document.tags.H1.fontSize = theFontSizes[currentScreen].h1
document.tags.H1.fontWeight = "bold"


document.tags.PRE.fontSize = theFontSizes[currentScreen].pre;
document.tags.TT.fontSize = theFontSizes[currentScreen].tt;
document.tags.P.fontSize = theFontSizes[currentScreen].p;
document.tags.LI.fontSize = theFontSizes[currentScreen].li;
document.tags.UL.fontSize = theFontSizes[currentScreen].ul;
document.tags.OL.fontSize = theFontSizes[currentScreen].ol;
document.tags.DL.fontSize = theFontSizes[currentScreen].dl;
document.tags.DT.fontSize = theFontSizes[currentScreen].dt;
document.tags.DD.fontSize = theFontSizes[currentScreen].dd;
document.tags.BLOCKQUOTE.fontSize = theFontSizes[currentScreen].blockquote;
document.tags.TH.fontSize = theFontSizes[currentScreen].th
document.tags.TD.fontSize = theFontSizes[currentScreen].td


document.classes.titlepage.all.fontSize = theFontSizes[currentScreen].titlepage
document.classes.titlepage.all.fontWeight = "bold"
document.classes.titlepage.all.textAlign = "center"

document.classes.small.all.fontSize = theFontSizes[currentScreen].small
document.classes.medium.all.fontSize = theFontSizes[currentScreen].medium
document.classes.large.all.fontSize = theFontSizes[currentScreen].large


document.classes.footnote.all.fontSize = theFontSizes[currentScreen].small
document.classes.footnote.all.textAlign = "right"

// CUSTOMIZATIONS!

document.tags.PRE.fontWeight = "bold"
document.classes.coloremph.all.color = "blue"
document.classes.agendahilite.all.color = "red"
document.classes.agendahilite.all.backgroundColor = "yellow"
document.classes.bothcssjsshilite.all.color =  "blue"


// test



