/*  
  menubar.js
  09/04/97 Henri Torgemane ( henri@netscape.com ) for Netscape Communications Corporation

*/


MenuConfig={};
MenuConfig.fontFace="MS Sans Serif,Arial,Helvetica";
MenuConfig.fontSize="-2";
MenuConfig.child_delay=300;
MenuConfig.leftMargin=16;
MenuConfig.childIconWidth=4;
MenuConfig.childIconHeight=7;
MenuConfig.basePath="images/"
MenuConfig.unselectedChildIcon=new Image()
MenuConfig.unselectedChildIcon.src='images/child_arrow.gif';
MenuConfig.selectedChildIcon=new Image()
MenuConfig.selectedChildIcon.src='images/child_arrow_i.gif';
MenuConfig.openedChildIcon=new Image()
MenuConfig.openedChildIcon.src='images/child_arrow_i.gif';
MenuConfig.checkedIconWidth=7;
MenuConfig.checkedIconHeight=7;
MenuConfig.unselectedCheckedIcon=new Image()
MenuConfig.unselectedCheckedIcon.src='images/checked.gif';
MenuConfig.selectedCheckedIcon=new Image()
MenuConfig.selectedCheckedIcon.src='images/checked_i.gif';
MenuConfig.textColor="Black";
MenuConfig.backgroundColor="#C0C0C0";
MenuConfig.borderColor1="#ffffff";
MenuConfig.borderColor2="#808080";
MenuConfig.borderColor3="#000000";
MenuConfig.selectedBackgroundColor="#000080";
MenuConfig.selectedTextColor="White"
MenuConfig.loaded=false;
MenuConfig.menubarCreated=false;
MenuConfig.watch('basePath', function(a,b,c) {
  MenuConfig.unselectedChildIcon=new Image()
  MenuConfig.unselectedChildIcon.src=c+'child_arrow.gif';
  MenuConfig.selectedChildIcon=new Image()
  MenuConfig.selectedChildIcon.src=c+'child_arrow_i.gif';
  MenuConfig.openedChildIcon=new Image()
  MenuConfig.openedChildIcon.src=c+'child_arrow_i.gif';
  MenuConfig.unselectedCheckedIcon=new Image()
  MenuConfig.unselectedCheckedIcon.src=c+'checked.gif';
  MenuConfig.selectedCheckedIcon=new Image()
  MenuConfig.selectedCheckedIcon.src=c+'checked_i.gif';
  return c;
} );


  /////////////////////////////// interface watchers.. //////////////////////////////////////

MenuConfig.WindowOnMouseDown=function (event) {
   if (MenuConfig.menubarCreated) {
    //first, find if we are on the menu, or on another part of the window.
    var k=event.target;
    while ((k!=window)&&(k.constructor!=Layer||k.name.substring(0,8)!='menubar_') ) {
      k=k.__parent__;
    }
    if (k==window) {
      MenuBar.switchTitleTo(null)
    }
  }
  if (MenuConfig.saveWindowOnMouseDown)
      return MenuConfig.saveWindowOnMouseDown(event)
  else
      return routeEvent(event)
}

MenuConfig.WindowOnBlur=function (event) {
  if (MenuConfig.menubarCreated) {
    if (event.target==window)
      MenuConfig.aboutToBlur=setTimeout('MenuConfig.realBlur();MenuConfig.aboutToBlur=-1',10);
  }
  if (MenuConfig.saveWindowOnBlur)
      return MenuConfig.saveWindowOnBlur(event)
  else
      return routeEvent(event)
}

MenuConfig.WindowOnFocus=function (event) {
  if (MenuConfig.menubarCreated) {
    if (event.target==window) {
     if (MenuConfig.aboutToBlur==-1) {
      MenuConfig.realFocus();
     } else {
      clearTimeout(MenuConfig.aboutToBlur);
      MenuConfig.aboutToBlur=-1
     }
    }
  }
  if (MenuConfig.saveWindowOnFocus)
      return MenuConfig.saveWindowOnFocus(event)
  else
      return routeEvent(event)
}
MenuConfig.aboutToBlur=-1;

MenuConfig.realBlur=function () {
    MenuBar.switchTitleTo(null);
  }

MenuConfig.realFocus=function () {
  }

MenuConfig.WindowOnLoad=function (event) {
  MenuConfig.loaded=true;

  if (MenuConfig.saveWindowOnLoad)
    return MenuConfig.saveWindowOnLoad(event);
  else
    return routeEvent(event);
}

MenuConfig.saveWindowOnMouseDown=window.onmousedown;
MenuConfig.saveWindowOnBlur=window.onblur;
MenuConfig.saveWindowOnFocus=window.onfocus;
MenuConfig.saveWindowOnLoad=window.onload;
window.captureEvents(Event.MOUSEDOWN);
window.onmousedown=MenuConfig.WindowOnMouseDown;
window.onblur=MenuConfig.WindowOnBlur;
window.onfocus=MenuConfig.WindowOnFocus;
window.onload=MenuConfig.WindowOnLoad;




function MenuBar(param) {
	var ref=this;

    var menuWidth=innerWidth 

    MenuBar.curTitle=null;

    var doc=MenuBar.getDocument();

    doc.write(
	 '<layer name=menubar_root clip='+menuWidth+',1 top=0 left=0 visibility=hide>'+
       '<layer name=bg bgcolor='+MenuConfig.backgroundColor+' clip='+menuWidth+',1 >'+
         '<layer name=bg1 bgcolor='+MenuConfig.borderColor2+' ></layer>'+
         '<layer name=bg2 bgcolor='+MenuConfig.borderColor3+' ></layer>'+
       '</layer>'+
     '</layer> ' );
	 doc.close();

    var retLayer=doc.layers.menubar_root;
	if (document.layers[0]!=retLayer)
	  retLayer.moveAbove(document.layers[0]);

    var h=retLayer.clip.width;
    var v=retLayer.clip.height;
    var bg=retLayer.document.bg;
    bg.clip.width=h;
    bg.document.bg1.clip.width=h;
    bg.document.bg1.clip.height=1;
    bg.document.bg2.clip.width=h;
    bg.document.bg2.clip.height=1;

    retLayer.captureEvents( Event.MOUSEDOWN );
    retLayer.onmousedown=ref.mbmdown;
    retLayer.zIndex=1e5; // closest synonym for 'above everything..'


    var j=0;
    for (a in param) {
		  var menu=new Menu(a,param[a]);
          ref[j]=menu;
		  j++;
    }
    ref.size=j;
	
// Now, the events...

	ref.layer=retLayer;
	retLayer.ref=ref;

	ref.adjustTitles();
	
	MenuConfig.menubarCreated=true;
}

MenuBar.getDocument=function () {
  if (!MenuConfig.loaded) {
    document.close=function(){};
    return document;
  }
  var tmp=new Layer(innerWidth);
  return tmp.document;
}

MenuBar.prototype.mbmdown=function (e) {
    if (e.target.__parent__.name.substring(0,2)=='bg')
      MenuBar.switchTitleTo(null)
    return routeEvent(e);
  }

MenuBar.prototype.add=function (title){ // add a title at the end of the bar..
		var ref=this;
		ref[ref.size++]=title.menu;
		ref.adjustTitles();
		return ref;
	}

MenuBar.prototype.remove=function (index){
		var ref=this;
		if (typeof index!='number') {
		  for (var i=0;i<ref.size;i++)
		    if (ref[i]==index) {
			  index=i;
			  i=ref.size;
			}
		}
		if (index>=ref.size)
		  return ref;
		for (var k=index;k<ref.size-1;k++)
		  ref[k]=ref[k+1];
		ref.size--;
		ref.adjustTitles();
		return ref;
	}

MenuBar.prototype.removeAll=function () {
		var ref=this;
		while (ref.size>0)
		  ref.remove(0);
		return ref;
	}

MenuBar.prototype.insert=function (title,index){
		var ref=this;
		if (index>=ref.size)
		  return this.addTitle(title);
		ref.size++;
		for (var k=ref.size;k>index;k--)
		  ref[k]=ref[k-1];
		ref[index]=title.menu;
		ref.adjustTitles();
		return ref;
	}

MenuBar.prototype.adjustTitles=function () {
	  var ref=this;
	  var retLayer=ref.layer;
      var offsetX=8;
	  var maxY=0;
	  for (var j=0;j<ref.size;j++) {
		  ref[j].parent.parent=ref;
          ref[j].parent.layer.moveTo(offsetX,3);
          ref[j].parent.layer.moveAbove(retLayer.document.bg);
          ref[j].parent.layer.visibility='inherit';
          ref[j].parent.index=j;

          offsetX+=ref[j].parent.layer.clip.width;
		  if (maxY<ref[j].parent.layer.clip.height)
		    maxY=ref[j].parent.layer.clip.height;
	  }
	  var bg=retLayer.document.bg;
	  retLayer.clip.height=maxY+5;
	  bg.clip.height=maxY+5;
	  bg.document.bg1.top=maxY+3
	  bg.document.bg2.top=maxY+4;
	}

MenuBar.prototype.showIn=function (container) {
	  var that=this.layer;
	  if (that!=container.document.layers[0])
	    that.moveAbove(container.document.layers[0]);
	  that.visibility='inherit';
	}


MenuBar.switchTitleTo=function (newTitle) {
	var oldTitle=MenuBar.curTitle;
	if (oldTitle==newTitle) return;
	if (oldTitle!=null) {
	  oldTitle.hide();
	}
	if (newTitle!=null) {
	  newTitle.show();
	}
	MenuBar.curTitle=newTitle;
  }


/////////////


//*************************************//
//*************************************//
//*************************************//


  // return a layer and a reflection object
  // { ref:ref_obj, layer:layer_obj }
  function Menu(name,data) {
    var ref=this;
    var retLayer;
	if (typeof data=='undefined') 
	  data={};
	if (typeof name=='undefined')
	  name='undefined';

    var doc=MenuBar.getDocument();

    doc.write(
    '<layer name=menubar_menu visibility=hide>'+
    ' <layer name=bg visibility=inherit bgcolor='+MenuConfig.borderColor3+' >'+
         '<layer name=bg1 top=0 left=0 bgcolor='+MenuConfig.backgroundColor+' ></layer>'+
         '<layer name=bg2 top=1 left=1 bgcolor='+MenuConfig.borderColor2+' ></layer>'+
         '<layer name=bg3 top=1 left=1 bgcolor='+MenuConfig.borderColor1+' ></layer>'+
         '<layer name=bg4 top=2 left=2 bgcolor='+MenuConfig.backgroundColor+' ></layer>'+
    ' </layer>'+
    '</layer> ' );
	doc.close()
    retLayer=doc.layers.menubar_menu;
    ref.items=[];
    ref.childs=[];
	if (retLayer!=document.layers[0])
	  retLayer.moveAbove(document.layers[0]);
	retLayer.zIndex=1e5;

    var k=0;
    for (b in data) {
      ref[k]=new MenuItem(b,data[b])
      k++;
    }
    ref.size=k;


    ref.curItem=null;
    retLayer.ref=ref;
	ref.layer=retLayer;

    ref.adjustItems();

	var title=new Menu.Title(name,ref);
	ref.parent=title.layer;
	ref.parent=title;
	ref.name=name;
    ref.sub=false;

  }


Menu.Title=function (id,menu) {
      var retLayer;
	  var obj=this;

	  var doc=MenuBar.getDocument();

      doc.write(
		 '<layer name=menubar_title visibility=hide z-index=10><font face="'+MenuConfig.fontFace+'" size='+MenuConfig.fontSize+'>'+
         '<layer name=ta top=0 left=0 ><font color='+MenuConfig.textColor+'>&nbsp;&nbsp;'+id+'&nbsp;&nbsp;</font></layer>'+
         '<layer name=tb bgcolor='+MenuConfig.selectedBackgroundColor+' visibility=hide top=0 left=0 ><font color='+MenuConfig.selectedTextColor+'>&nbsp;&nbsp;'+id+'&nbsp;&nbsp;</font></layer>'+
       '</font></layer> ' );
	  doc.close();
      retLayer=doc.layers.menubar_title;
      var ta=retLayer.document.ta;
      var tb=retLayer.document.tb;
      retLayer.clip.top-=2;
      retLayer.clip.bottom+=2;
      ta.clip.top-=2;
      ta.clip.bottom+=2;
      tb.clip.top-=2;
      tb.clip.bottom+=2;
      ta.captureEvents( Event.MOUSEDOWN | Event.MOUSEMOVE | Event.MOUSEUP );
      tb.captureEvents( Event.MOUSEUP   | Event.MOUSEMOVE);

      ta.onmousedown=obj.lamdown;
      tb.onmouseup=obj.lbmup;
	  ta.onmouseup=obj.lamup;
      ta.onmousemove=obj.lammove;
      tb.onmousemove=obj.lammove;
	  obj.name=id
	  obj.menu=menu
	  obj.layer=retLayer;

	  retLayer.ref=obj;
	  obj.child=menu;
	  menu.parent=obj;
	  menu.name=id;
      menu.sub=false;
      return obj;
    }

Menu.Title.prototype.show=function () {
		  var that=this.layer;
          that.document.tb.visibility='inherit';
          that.document.ta.visibility='hide';
		  this.child.show();
		}

Menu.Title.prototype.hide=function () {
		  var that=this.layer;
          that.document.tb.visibility='hide';
          that.document.ta.visibility='inherit';
		  this.child.hide();
		}

Menu.Title.prototype.contains=function (x,y) {
		  var that=this.layer;
		  return (that.pageX+that.clip.left<=x &&
		          that.pageY+that.clip.top<=y &&
				  that.pageX+that.clip.width>=x &&
				  that.pageY+that.clip.height>=y);
		}

Menu.Title.prototype.lamdown=function () {
		var ref=this.parentLayer.ref;
		var that=this;
		ref.child.layer.pageX=that.pageX;
		ref.child.layer.pageY=that.pageY+that.clip.height-2;
		ref.child.layer.zIndex=1e5;
        MenuBar.switchTitleTo( ref ); 
      }
Menu.Title.prototype.lamdown.aux=function(l,h){l.onmouseup=h}

Menu.Title.prototype.lbmup=function (e) {
		var ref=this.parentLayer.ref;
	    ref.lamup.execItem(MenuBar.curTitle.child,e)
        MenuBar.switchTitleTo(null); 
      }

Menu.Title.prototype.lamup=function (e) {
		var ref=this.parentLayer.ref;
		if (MenuBar.curTitle)
		  ref.lamup.execItem(MenuBar.curTitle.child,e);
      }
Menu.Title.prototype.lamup.execItem= function (q,e) {
		    var those=null;
		
			if (q.curItem&&q.curItem.contains(e.pageX,e.pageY)) {
			  those=q.curItem;
			  if (!those.hr)
			    those.elbmup();
			  return those;
			}
		    for (var i=0;i<q.size&&those==null;i++) {
			  if (q[i].contains(e.pageX,e.pageY)) {
			    those=q[i];
				if (those.elbmup)
				  those.elbmup(those) 
			  } else if (q[i].child&&q[i].child.layer.visibility!='hide') {
			    those=MenuBar.curTitle.lamup.execItem(q[i].child,e);
			  }
			}
			return those;
		}

Menu.Title.prototype.lammove=function (e) {
		var ref=this.parentLayer.ref;
		return ref.activate(e.pageX,e.pageY)
      }

Menu.Title.prototype.activate=function (x,y) {
        if (MenuBar.curTitle!=null) { 
			  var those=null;
			  var p=this.parent
			  for (var i=0;i<p.size;i++) {
			    if (p[i].parent.contains(x,y)) {
				  those=p[i].parent;
			      those.child.layer.pageX=those.layer.pageX;
			      those.child.layer.pageY=those.layer.pageY+those.layer.clip.height-2;
				  MenuBar.switchTitleTo(p[i].parent);
				}
			  }
			  if (those==null) {
			    those=this.activate.lookItem(MenuBar.curTitle.child,x,y);
		      }
			  if (those==null) {
			    MenuBar.curTitle.child.switchItemTo(null);
			  }
		  }
        return false;
	  }

Menu.Title.prototype.activate.lookItem=function (q,x,y) {
		    var those=null;
			
			if (MenuBar.curTitle.child.curItem&&MenuBar.curTitle.child.curItem.contains(x,y)) 
			  return MenuBar.curTitle.child.curItem;
		    for (var i=0;i<q.size&&those==null;i++) {
			  if (q[i].contains(x,y)) {
			    those=q[i];
				if (!those.hr)
				  those.activate() 
			  } else if (q[i].child&&q[i].child.layer.visibility!='hide') {
			    those=this.lookItem(q[i].child,x,y);
			  }
			}
			return those;
		}



Menu.prototype.add=function (item) {
		var retLayer=this.layer;
		var ref=this;
		if (item.parent!=null)
		  item.parent.remove(item.index);
        ref[ref.size]=item
		ref.size++;

		this.adjustItems();

    	return ref;
	}

Menu.prototype.remove=function (index) {
		var retLayer=this.layer;
		var ref=this;
		if (typeof index!='number') {
		  for(var i=0;i<ref.size;i++)
		    if (ref[i]==index) {
			  index=i;
			  i=ref.size;
			}
		}
		if (index>=ref.size)
			return ref;
		ref[index].parent=null;
		ref[index].layer.visibility='hide'
		for (var k=index;k<ref.size-1;k++)
		  ref[k]=ref[k+1];
		ref.size--;

		this.adjustItems();
		return ref;
	}

Menu.prototype.removeAll=function () {
		var ref=this;
		while (ref.size>0)
		  ref.remove(0);
		return ref;
	}

Menu.prototype.insert=function (item,index) {
		var retLayer=this.layer;
		var ref=this;
		if (index>=ref.size)
		  return add(item);
		if (item.parent!=null)
		  item.parent.remove(item.index);
		ref.size++;
		for (var k=ref.size;k>index;k--)
		  ref[k]=ref[k-1]
		ref[index]=item;

		this.adjustItems();
		return ref;
	}

Menu.prototype.show=function () {
	  if (this.sub) {
	    if (this.parent.parent.layer.visibility=='hide')
		  return; // Can't exist on slime alone.
		this.parent.parent.switchItemTo(this.parent);
		this.layer.moveAbove(this.parent.parent.layer);
        var item=this.parent;
        item.layer.document.lb.document.achild.document.images[0].src=MenuConfig.openedChildIcon.src; 
        this.layer.pageX=item.layer.pageX+item.layer.clip.width;
        this.layer.pageY=item.layer.pageY-4;
		for (var i=0;i<item.parent.childs.length;i++)
		  if (item.parent.childs[i]!=this) item.parent.childs[i].hide();
	  }
      this.layer.zIndex=1e5;
	  this.layer.visibility='inherit'
	  this.currentChild=null;
	}

Menu.prototype.hide=function () {
	  for (var i=0;i<this.childs.length;i++)
	    this.childs[i].hide();
	  this.layer.visibility='hide';
	  this.switchItemTo(null);
	  this.currentChild=null;
	}

Menu.prototype.mouseout=function () {
	    if (this.currentChild==null)
		  this.switchItemTo(null)
	}

Menu.prototype.switchItemTo=function (n) {
	  var m=this.curItem;
	  if (m==n) return;
      if (m!=null&&typeof m!='undefined') {
	    m.hide()
      }
      if (n!=null&&typeof n!='undefined') {
	    n.show();
      }
      this.curItem=n;
    }

Menu.prototype.adjustItems=function () {
	    var retLayer=this.layer;
		var ref=this;
		retLayer.clip.width=0;
        var offsetY=4;

	    for (k=0;k<ref.size;k++) {
	      ref[k].parent=ref;
	      ref.items[k]=ref[k];
		  ref[k].index=k;
	      ref[k].layer.moveAbove(retLayer.document.bg);
	      ref[k].layer.__parent__=retLayer.document;
	      ref[k].layer.left=2;
      	  ref[k].layer.top=offsetY;
	      ref[k].layer.parent=retLayer;
	      ref[k].layer.index=k;
	      ref[k].layer.visibility='inherit'
	      if (retLayer.clip.width<ref[k].layer.clip.width+2+16)
	        retLayer.clip.width=ref[k].layer.clip.width+2+16;
	      offsetY+=ref[k].layer.clip.height;
    	}

        var nbChild=0;
		ref.childs=[]; // reset the childs array
        for (var i=0;i<k;i++) {
      	  var r=ref.items[i];
		  var l=r.layer;
          l.clip.width=retLayer.clip.width;
          if (!r.hr) { 
        	l.document.la.clip.width=retLayer.clip.width
        	l.document.lb.clip.width=retLayer.clip.width
			if (l.document.lc) {
        	  l.document.lc.clip.width=retLayer.clip.width
        	  l.document.ld.clip.width=retLayer.clip.width
			}
          } else {
        	l.document.hr1.clip.width=retLayer.clip.width;
        	l.document.hr2.clip.width=retLayer.clip.width;
          }
      	  if (r.child) { 
        	r.child.childIndex=nbChild;
        	ref.childs[nbChild++]=r.child;
        	var l1=l.document.la.document.achild;
        	var l2=l.document.lb.document.achild;
	        l1.left=retLayer.clip.width-9+l.document.la.clip.left;
        	l1.top=(l.document.la.document.height-l1.document.height)/2;
        	l2.left=retLayer.clip.width-9+l.document.la.clip.left;
        	l2.top=(l.document.lb.document.height-l2.document.height)/2;
      	  }
    	}
	    retLayer.clip.width+=6;
	    retLayer.clip.height=offsetY+2;
		ref.setBorder();
	}

Menu.prototype.setBorder=function () {
      var bg=this.layer.document.bg;
      var h=this.layer.clip.width-1;
      var v=this.layer.clip.height-1;
      bg.clip.height=v+1;
      bg.clip.width=h+1;
      bg.document.bg1.clip.width=h;
      bg.document.bg1.clip.height=v;
      bg.document.bg2.clip.width=h-1;
      bg.document.bg2.clip.height=v-1;
      bg.document.bg3.clip.width=h-2;
      bg.document.bg3.clip.height=v-2;
      bg.document.bg4.clip.width=h-3;
      bg.document.bg4.clip.height=v-3;
    }



//*************************************//
//*************************************//
//*************************************//


  // return a layer, globbing all the layers for this item, and a reflection object

  function MenuItem(id,data) {
	var ref=this
    var leftMargin=MenuConfig.leftMargin;
	var childIconWidth=MenuConfig.childIconWidth;
	var childIconHeight=MenuConfig.childIconHeight;
	var checkedIconWidth=MenuConfig.checkedIconWidth;
	var checkedIconHeight=MenuConfig.checkedIconHeight;
    var retLayer;
	if (typeof data=='undefined')
	  data={};
	if (typeof data=='number') {
	  var tmp=data;
	  data={};
	  if (tmp&&MenuItem.CAN_DISABLE==MenuItem.CAN_DISABLE)
	    data.enabled=true;
	  if (tmp&&MenuItem.CAN_CHECK==MenuItem.CAN_CHECK)
	    data.checked=false;
	  if (tmp&&MenuItem.CAN_SUBMENU==MenuItm.CAN_SUBMENU)
	    data.child={};

	}

    var doc=MenuBar.getDocument();
	

    if (id.indexOf('<hr>')!=-1) {
      ref.name='<hr>';
      doc.write('<layer name=item left=0 top=0 >'+
        '<layer name=hr1 top=1 left=0 clip=1,1 bgColor='+MenuConfig.borderColor2+'></layer>'+
        '<layer name=hr2 top=2 left=0 clip=1,1 bgColor='+MenuConfig.borderColor1+'></layer>'+
      '</layer> ');
	  doc.close();
      retLayer=doc.layers.item;
      ref.hr=true;
      retLayer.clip.bottom+=6;
    } else {
      if (typeof data.leftMargin!='undefined')
        leftMargin=data.leftMargin;
      ref.name=id;
      var s=
	  '<layer top=0 left=0 name=item visibility=hide><font face="'+MenuConfig.fontFace+'" size='+MenuConfig.fontSize+'>'+
       '<layer name=la left='+leftMargin+' top=0><font color='+MenuConfig.textColor+'>'+id+'</font>';
	   if (typeof data.checked!='undefined') s+=
         '<layer name=checkme left='+(4-leftMargin)+' top=2 visibility=hide><img src="about:blank" width='+checkedIconWidth+' height='+checkedIconHeight+'></layer>'
	   if (typeof data.child!='undefined') s+=
         '<layer name=achild left=2 top=0 visibility=hide><img src="about:blank" width='+childIconWidth+' height='+childIconHeight+'></layer>'
	   s+=
       '</layer>'+
       '<layer name=lb left='+leftMargin+' top=0 bgcolor='+MenuConfig.selectedBackgroundColor+' visibility=hide><font color='+MenuConfig.selectedTextColor+'>'+id+'</font>';
	   if (typeof data.checked!='undefined') s+=
         '<layer name=checkme left='+(4-leftMargin)+' top=2 visibility=hide><img src="about:blank" width='+checkedIconWidth+' height='+checkedIconHeight+'></layer>'
	   if (typeof data.child!='undefined') s+=
         '<layer name=achild left=2 top=0 visibility=hide><img src="about:blank" width='+childIconWidth+' height='+childIconHeight+'></layer>'
	   s+=
       '</layer>'
	  if (typeof data.enabled!='undefined') s+=
       '<layer name=lc left='+leftMargin+' top=0 visibility=hide >'+
        '<layer name=p1 left=1 top=1><font color='+MenuConfig.borderColor1+'>'+id+'</font></layer>'+
        '<layer name=p2 left=0 top=0><font color='+MenuConfig.borderColor2+'>'+id+'</font></layer>'+
       '</layer>'+
       '<layer name=ld left='+leftMargin+' top=0 visibility=hide bgcolor='+MenuConfig.selectedBackgroundColor+'><font color='+MenuConfig.borderColor2+'  >'+id+'</font></layer>';
	  s+=
      '</font></layer> ' ;
	  doc.write(s);
	  doc.close();
      retLayer=doc.layers.item;
      var l=retLayer.document;
      var la=l.la
      var lb=l.lb
      var lc=l.lc
      var ld=l.ld
      var lf=la.document.checkme
      var lg=lb.document.checkme
	  if (lf)
        lf.document.images[0].src=MenuConfig.unselectedCheckedIcon.src;
	  if (lg)
        lg.document.images[0].src=MenuConfig.selectedCheckedIcon.src;

      retLayer.clip.top-=2;
      retLayer.clip.bottom+=2;
      la.clip.top-=2;
      lb.clip.top-=2;
      if (lc) lc.clip.top-=2;
      if (ld) ld.clip.top-=2;
      la.clip.bottom+=2;
      lb.clip.bottom+=2;
      if (lc) lc.clip.bottom+=2;
      if (ld) ld.clip.bottom+=2;

      la.clip.left=-leftMargin;
      lb.clip.left=-leftMargin;
      if (lc) lc.clip.left=-leftMargin;
      if (ld) ld.clip.left=-leftMargin;
      la.captureEvents( Event.MOUSEMOVE );
      lb.captureEvents( Event.MOUSEOUT | Event.MOUSEUP | Event.MOUSEMOVE | Event.MOUSEDOWN);
      if (lc) lc.captureEvents( Event.MOUSEMOVE );
      if (ld) ld.captureEvents( Event.MOUSEOUT | Event.MOUSEMOVE);

      la.onmousemove=ref.elammove;
      if (lc) lc.onmousemove=ref.elammove;
	  lb.onmouseup=ref.elbmup2;
	  lb.onmousedown=ref.elbmdown;
      lb.onmousemove=ref.elbmmove;
      if (ld) ld.onmousemove=ref.elbmmove;
      if (!data.enabled && typeof data.enabled!='undefined') {
        la.visibility='hide'
        lb.visibility='hide'
        if (lc) lc.visibility='inherit'
        ref.enabled=false;
      } else {
        ref.enabled=true;
      }
	  if (typeof data.enabled!='undefined') {
        ref.watch('enabled',ref.watchEnabled);
	  }
      if (data.checked) {
        lf.visibility='inherit';
        lg.visibility='inherit';
        ref.checked=true;
      } else
        ref.checked=false;
	  if (lf)
        lf.top=(la.document.height-lf.document.height)/2;
	  if (lg)
        lg.top=(lb.document.height-lg.document.height)/2;
	  if (typeof data.checked!='undefined')
        ref.watch('checked',ref.watchChecked);
      if (data.child) {
        var ca=la.document.achild
        var cb=lb.document.achild
        ca.visibility='inherit';
        cb.visibility='inherit';
        ca.document.images[0].src=MenuConfig.unselectedChildIcon.src;
        cb.document.images[0].src=MenuConfig.selectedChildIcon.src;
        ref.exec=null;
        ref.child=new Menu(id,data.child);
        ref.child.parent=ref;
		ref.child.sub=true;
      } else {
        ref.child=null;
		if (typeof data.exec == 'string')
          ref.exec=new Function('item',data.exec);
		else
          ref.exec=data.exec;
      }
    }
    retLayer.ref=ref;
	ref.layer=retLayer;
	ref.parent=null;
  }
MenuItem.CAN_DISABLE=1;
MenuItem.CAN_CHECK=2;
MenuItem.CAN_SUBMENU=4;

MenuItem.prototype.show=function () {

        if (this.enabled) {
		  if (this.layer.document.lb.document.achild)
            this.layer.document.lb.document.achild.document.images[0].src=
              MenuConfig.selectedChildIcon.src; 
          this.layer.document.lb.visibility='inherit';
          this.layer.document.la.visibility='hide';
        } else {
          this.layer.document.ld.visibility='inherit';
          this.layer.document.lc.visibility='hide';
        }
	}

MenuItem.prototype.hide=function () {

        if (this.enabled) {
          this.layer.document.la.visibility='inherit';
          this.layer.document.lb.visibility='hide';
        } else {
          this.layer.document.lc.visibility='inherit';
          this.layer.document.ld.visibility='hide';
        }
	}

MenuItem.prototype.contains=function (x,y) {
	  var that=this.layer;
	  return (that.pageX+that.clip.left<=x &&
	          that.pageY+that.clip.top<=y &&
			  that.pageX+that.clip.width>=x &&
			  that.pageY+that.clip.height>=y);
	}

MenuItem.prototype.watchEnabled=function (elem,data1,data2) {
      var l=this.layer;
      l.document.la.visibility=data2?'inherit':'hide';
      l.document.lb.visibility='hide';
      l.document.lc.visibility=data2?'hide':'inherit';
      l.document.ld.visibility='hide'
      return data2?true:false; // should convert stuff like null,1,and 'hello' into booleans.
    }

MenuItem.prototype.watchChecked=function (elem,data1,data2) {
      var s=data2?'inherit':'hide';
      var l=this.layer;
      l.document.la.document.checkme.visibility=s;
      l.document.lb.document.checkme.visibility=s;
      return data2?true:false;
    }

MenuItem.prototype.elammove=function () {
	  var ref=this.parentLayer.ref;
	  return ref.activate();
    }

MenuItem.prototype.activate=function () {
	  var ref=this;
      var k=ref.layer;

      clearTimeout(ref.parent.openTimer)
	  if (ref.parent.sub) {
	    ref.parent.parent.parent.switchItemTo(ref.parent.parent);
		clearTimeout(ref.parent.parent.parent.closeTimer);
		clearTimeout(ref.parent.parent.parent.openTimer);
	  }

	  ref.parent.switchItemTo(ref)
      if (ref.child) {
	      var tmp=new Function("a","b","exec(a,b)");
		  tmp.exec=ref.activate.opensub;
	      ref.parent.openTimer=
          setTimeout(tmp,MenuConfig.child_delay,ref.parent,ref.child); 
      } else {
		  var tmp=new Function("a","b","exec(a,b)");
		  tmp.exec=ref.activate.closesub;
		  ref.parent.closeTimer=
		  setTimeout(tmp,MenuConfig.child_delay,ref.parent,ref.parent.currentChild); 
	  }
      return false;
	}

MenuItem.prototype.activate.opensub=function (menu,child) {
	    child.show();
		menu.currentChild=child;
	  }

MenuItem.prototype.activate.closesub=function (menu,child) {
	    if (child!=null) child.hide();
		menu.currentChild=null;
	  }


MenuItem.prototype.elbmmove=function (e) {
	  if (MenuBar.curTitle&&MenuBar.isdown)
	    MenuBar.curTitle.activate(e.pageX,e.pageY)
      return false;
    }

MenuItem.prototype.elbmdown=function () {
	  MenuBar.isdown=true;
	}

MenuItem.prototype.elbmup=function () {
	  MenuBar.isdown=false;
	  var k=this;
      if (k.exec&&k.enabled!=false) {
        MenuBar.switchTitleTo(null); 
        setTimeout(k.exec,0,k); // never trust a user-defined function. The user is evil.
      }
    }

MenuItem.prototype.elbmup2=function (e) {
  if (MenuBar.curTitle)
	MenuBar.curTitle.lamup.execItem(MenuBar.curTitle.child,e)
}
