// If your presentation is longer than 125 slides,
// you could change the Array size below.
filename = new Array(125);

first_slide = 0;
last_slide = 0;
current_slide = 1;
slides_inserted = 0;
slides_deleted = 0;
show_slide_filename = 0;


/* function AddSlide adds a slide to the presentation at the end.      */
/*                                                                     */
/* parameter name is the name of the file, without the .htm extension. */

function AddSlide(name)
{
	last_slide++;
	if(name == null) name = last_slide-slides_inserted+slides_deleted;
	else {
		slides_inserted++;
	}
	filename[last_slide] = name + ".htm";
}


// DON'T EDIT ANY OF THE TEXT ABOVE THIS LINE!!!
// It's source code you don't need to touch and should not touch.
//
// To add, delete, and reorder slides, 
// just add, delete, and reorder the AddSlide("FILENAME")
// entries below.  Each name in double quotes is the name
// of an HTML file in this presentation directory.
//
// Within the quotes, don't include an extension like .htm or .html.
// This application automatically adds .htm to the name when it
// looks in the directory for the file.  In the directory, the
// HTML file *must* have the three letter extension .htm.


// Keep these first three slides (Logopage, Title, S_agenda)
// in your presentation so we have a standard look and feel.
// (Edit the contents of the Title and S_agenda slide.)

// standup version for delivery in front of audience
var standup = true

// version to put on the WWW
var online  = false

// display URLs for people to write down
var showURLs = true

// extra slides in tutorial
var tutorial = true

if (!(tutorial || online)) {
AddSlide("logopage");	// 
}

if (tutorial) {
AddSlide("titletut");	// tutorial title slide
}
else {
AddSlide("title");	// title slide
}

AddSlide("J_agenda");
AddSlide("J_whatdo");
AddSlide("J_benef");
AddSlide("J_benef2");
AddSlide("J_whatCS");
AddSlide("J_whyJS");
AddSlide("J_whyJS2");
AddSlide("J_newtag");
AddSlide("J_newsel");
AddSlide("J_consel");
AddSlide("J_newprp");
AddSlide("J_where");
AddSlide("J_where1");
AddSlide("J_where2");
AddSlide("J_wherec");
AddSlide("J_scrsty");
AddSlide("J_scrst2");
AddSlide("J_where3");
AddSlide("J_units");
AddSlide("C_units2");
AddSlide("J_counit");
AddSlide("J_couni2");
AddSlide("J_coment");
AddSlide("J_block");
AddSlide("J_block2"); ////
AddSlide("GrMargin");
AddSlide("J_layout");
AddSlide("J_lay2");
AddSlide("J_margns"); ////* 
AddSlide("J_marga4");
AddSlide("J_padprp"); ////* 
AddSlide("J_pading"); ////* 
AddSlide("J_pada4"); ////* 
AddSlide("J_borda"); ////* 
AddSlide("J_border"); ////* 
AddSlide("J_borda4");
AddSlide("J_bordst");
AddSlide("J_bordco");
AddSlide("J_bord3");
//// LATER, ADD IN JS ACCESSIBILITY DEMOS OF CSS BORDER TYPES


AddSlide("J_with"); //// 
AddSlide("J_color");
AddSlide("J_class");
AddSlide("J_class2");
AddSlide("J_ids");
AddSlide("J_idsa");
AddSlide("J_ids2");
AddSlide("J_span");
AddSlide("J_div");
AddSlide("J_fontS");
AddSlide("J_fontW");
AddSlide("J_fontW2"); //// 
AddSlide("J_fntSzA");
AddSlide("J_fntSzR");
// AddSlide("J_fntSzI"); //// 
AddSlide("J_fontFm");
AddSlide("J_decor");
AddSlide("J_xform");
AddSlide("J_align");
AddSlide("J_indent");
AddSlide("J_listST");
AddSlide("J_listUL");
AddSlide("J_listOL");
AddSlide("J_multi");
AddSlide("J_multi2");

AddSlide("J_DevEx1");
AddSlide("J_DevCo1");
AddSlide("J_DevCo2");
AddSlide("J_DevCo3");
AddSlide("J_DevCo4");
AddSlide("J_DevAd1");

if (standup) {
AddSlide("J_DevAd2");
}

AddSlide("J_summ");

if (showURLs) {
AddSlide("J_SCURL");
AddSlide("J_SCURL2");
}


// Keep this last slide (logopage) in your presentation 
// so every presentation ends with the logo.

if (!(tutorial || online)) {
AddSlide("logopage");	// 
}





