// target is string to test.
// pattern is r.e. description in Perl format.
// pattern is not a string! Do not enclose in double quotes. Enclose in //.
function reMatch (target, pattern)
{  var result = target.match(pattern)
   return (result[0] == target)
}


function reMatchTest (target, pattern, testlabel)
{  outputTable += "<TR><TD ALIGN=LEFT>" + target + "</TD><TD ALIGN=CENTER>" + pattern + "</TD><TD ALIGN=CENTER>" + reMatch(target,pattern) + "</TD><TD ALIGN=CENTER>" + testlabel + "</TD></TR>"
}

var outputTable = "<TABLE BORDER><TR><TH ALIGN=LEFT>Target</TH><TH ALIGN=CENTER>Pattern</TH><TH ALIGN=CENTER>Match?</TH><TH ALIGN=CENTER>type</TH></TR>"

var reInteger = /\d*/
var reSignedInteger = /(\+|-)?\d+/

// BUG: would accept .
var reFloat = /\d*\.\d*/
var reSignedFloat = /(\+|-)?\d*\.\d*/

var reSSN = /\d\d\d(\s|-)?\d\d(\s|-)?\d\d\d\d/


reMatchTest("123",reInteger,"unsigned integer")		// 

//reMatchTest("1234567890",reSignedInteger,"signed int")
reMatchTest("+1",reSignedInteger,"signed integer")
//reMatchTest("-1",reSignedInteger,"signed int")

reMatchTest("0.2",reFloat,"float")
reMatchTest("-7.5",reSignedFloat,"signed float")
//reMatchTest("123-456-7890",reSSN,"U.S. SSN")


outputTable += "</TABLE>"

document.write(outputTable)


